class RangeFilter:

    """
    Filters events in a DateTime range based on start end values.
    Events must have getStart() getEnd() methods.
    """

    def __init__(self, start, end, events):
        self.start = start
        self.end = end
        self.events = events

    def getInRange(self):
        "Returns events in range"
        start = self.start
        end = self.end
        events = self.events
        result = []
        for event in events:
            event_start = event.getStart()
            event_end = event.getEnd()
            if event_start and event_end:
                if (start <= event_start <= end
                    or start <= event_end <= end
                    or (event_start <= start and event_end >= end)):
                    result.append(event)
        return result

