# -*- coding: ISO-8859-1 -*-

# Copyright (c) 2005 by Max M
# Generator: ArchGenXML Version 1.4 devel 4 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA

__author__  = '''Max M <maxm@mxm.dk>'''
__docformat__ = 'plaintext'

from types import StringTypes
from AccessControl import ClassSecurityInfo, Permissions
from DateTime import DateTime
from CatalogWrapper import CatalogWrapper
from GantAdapter import GantAdapter
from Products.Archetypes.atapi import *
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.utils import getToolByName
from StressAdapter import StressAdapter
from HourAdapter import HourAdapter
from TimeRegistrationMixin import TimeRegistrationMixin
from Products.mxmProjectManager.config import *

try: # 2.3 and 2.4+ compatible set import
    set
except NameError:  
    from sets import Set as set

schema= Schema((
    #Title of the object.
    StringField('title',
        widget=StringWidget(
            label='Title',
            label_msgid='mxmProjectManager_label_title',
            description='Enter a value for title.',
            description_msgid='mxmProjectManager_help_title',
            i18n_domain='mxmprojectmanager',
        ),
        accessor="Title",
    ),
    
    #Description of the object.
    TextField('description',
        widget=TextAreaWidget(
            label='Description',
            label_msgid='mxmProjectManager_label_description',
            description='Enter a value for description.',
            description_msgid='mxmProjectManager_help_description',
            i18n_domain='mxmprojectmanager',
        ),
        accessor="Description",
    ),
    
    TextField('body',
        widget=VisualWidget(
            label='Body',
            label_msgid='mxmProjectManager_label_body',
            description='Enter a value for body.',
            description_msgid='mxmProjectManager_help_body',
            i18n_domain='mxmprojectmanager',
        ),
    ),
    
    #Title of the object.
    IntegerField('viewRange',
        widget=IntegerWidget(
            label='Default day range',
            label_msgid='mxmProjectManager_label_view_range',
            description='How many days to view.',
            description_msgid='mxmProjectManager_help_view_range',
            i18n_domain='mxmprojectmanager',
        ),
        default=60,
    ),
    
    BooleanField('allSite',
        widget=BooleanWidget(
            label='All projects on the site',
            label_msgid='mxmProjectManager_label_allsite',
            description='View projects from the entire site.',
            description_msgid='mxmProjectManager_help_allsite',
            i18n_domain='mxmprojectmanager',
        ),
        default=0,
    ),
    
    
    # daily default hours
    
    FloatField('mondayDefault',
        widget=DecimalWidget(
            label='Monday hours',
            label_msgid='mxmProjectManager_label_mondayDefault',
            description='Default number of hours on a monday.',
            description_msgid='mxmProjectManager_help_mondayDefault',
            i18n_domain='mxmprojectmanager',
        ),
        default=8.0,
    ),
    FloatField('tuesdayDefault',
        widget=DecimalWidget(
            label='Tuesday hours',
            label_msgid='mxmProjectManager_label_tuesdayDefault',
            description='Default number of hours on a tuesday.',
            description_msgid='mxmProjectManager_help_tuesdayDefault',
            i18n_domain='mxmprojectmanager',
        ),
        default=8.0,
    ),
    FloatField('wednesdayDefault',
        widget=DecimalWidget(
            label='Wednesday hours',
            label_msgid='mxmProjectManager_label_wednesdayDefault',
            description='Default number of hours on a wednesday.',
            description_msgid='mxmProjectManager_help_wednesdayDefault',
            i18n_domain='mxmprojectmanager',
        ),
        default=8.0,
    ),
    FloatField('thursdayDefault',
        widget=DecimalWidget(
            label='Thursday hours',
            label_msgid='mxmProjectManager_label_thursdayDefault',
            description='Default number of hours on a thursday.',
            description_msgid='mxmProjectManager_help_thursdayDefault',
            i18n_domain='mxmprojectmanager',
        ),
        default=8.0,
    ),
    FloatField('fridayDefault',
        widget=DecimalWidget(
            label='Friday hours',
            label_msgid='mxmProjectManager_label_fridayDefault',
            description='Default number of hours on a friday.',
            description_msgid='mxmProjectManager_help_fridayDefault',
            i18n_domain='mxmprojectmanager',
        ),
        default=8.0,
    ),
    FloatField('saturdayDefault',
        widget=DecimalWidget(
            label='Saturday hours',
            label_msgid='mxmProjectManager_label_saturdayDefault',
            description='Default number of hours on a saturday.',
            description_msgid='mxmProjectManager_help_saturdayDefault',
            i18n_domain='mxmprojectmanager',
        ),
        default=0.0,
    ),
    FloatField('sundayDefault',
        widget=DecimalWidget(
            label='Sunday hours',
            label_msgid='mxmProjectManager_label_sundayDefault',
            description='Default number of hours on a sunday.',
            description_msgid='mxmProjectManager_help_sundayDefault',
            i18n_domain='mxmprojectmanager',
        ),
        default=0.0,
    ),
    
    
),
)

from Products.PlacelessTranslationService import getTranslationService

class mxmProjectManager(BaseFolder, GantAdapter, TimeRegistrationMixin):
    
    security = ClassSecurityInfo()
    
    __implements__ = (getattr(BaseFolder,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name             = 'Project manager'

    portal_type = meta_type    = 'mxmProjectManager' 
    allowed_content_types      = ['Project'] 
    filter_content_types       = 1
    global_allow               = 1
    allow_discussion           = 0
    content_icon               = 'mxmProjectManager.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "Project"
    typeDescMsgId              = 'description_edit_mxmprojectmanager'

    schema = BaseFolderSchema + \
             schema

    _at_rename_after_creation = True

    actions = (
        {
            'id': 'view', 
            'name': 'View', 
            'action': 'string:${object_url}/mxmProjectManager_view', 
            'permissions': (View,)
        }, 
        {
            'id': 'participants', 
            'name': 'Participants', 
            'action': 'string:${object_url}/mxmProjectManager_participants', 
            'permissions': (View,)
        }, 
        {
            'id': 'hours', 
            'name': 'Hours', 
            'action': 'string:${object_url}/mxmProjectManager_hours', 
            'permissions': (View,)
        }, 
        {
            'id': 'timereg', 
            'name': 'Time Registration',
            'action': 'string:${object_url}/mxmProjectManager_timereg', 
            'permissions': (View,)
        }, 
#        {
#            'id': 'schedule', 
#            'name': 'Schedule', 
#            'action': 'string:${object_url}/mxmProject_schedule', 
#            'permissions': (View,)
#        }, 
    )


    security.declareProtected(View, 'getProjectManager')
    def getProjectManager(self):
        "Returns self"
        return self

    security.declarePrivate('getCatalog')
    def getCatalog(self, return_objects=0):
        "Returns a wrapped catalog"
        catalog = getToolByName(self, 'portal_catalog')
        return CatalogWrapper(catalog, return_objects)

    security.declareProtected('View', 'getRequestDate')
    def getRequestDate(self, name):
        "Returns the date from the request"
        req = self.REQUEST
        session = req.SESSION
        SES_YEAR = 'mxmproject_%s_year'
        SES_MONTH = 'mxmproject_%s_month'
        SES_DAY = 'mxmproject_%s_day'
        year = req.get('%s_year' % name, session.get(SES_YEAR % name, None))
        month = req.get('%s_month' % name, session.get(SES_MONTH % name, None))
        day = req.get('%s_day' % name, session.get(SES_DAY % name, None))
        if year and month and day:
            session[SES_YEAR % name] = year
            session[SES_MONTH % name] = month
            session[SES_DAY % name] = day
            return DateTime(year, month, day)
        else:
            return None

    security.declareProtected('View', 'getStart')
    def getStart(self):
        "Returns the start date for project view"
        start = self.getRequestDate('start')
        if not start:
            start = self.ZopeTime()
        return start

    security.declareProtected('View', 'getEnd')
    def getEnd(self):
        "Returns the start date for project view"
        end = self.getRequestDate('end')
        if not end:
            end = self.ZopeTime() + self.getViewRange()
        return end

    security.declarePublic('getDateRangeDict')
    def getDateRangeDict(self):
        "Returns start time as dict."
        site_properties = getToolByName(self, 'portal_properties').site_properties
        first_year = site_properties.calendar_starting_year
        future_years = site_properties.calendar_future_years_available
        now = self.ZopeTime()
        start = self.getStart()
        end = self.getEnd()
        req = self.REQUEST
        ses = req.SESSION
        FILTER_ON = 'mxmproject_filter_on'
        filter_on = req.get('filter_on', 0)
        if req.has_key('filter_on'):
            ses[FILTER_ON] = req['filter_on']
        filter_on = ses.get(FILTER_ON, 0)
        drd = {
            'start_year':start.year(),
            'start_month':start.month(),
            'start_day':start.day(),
            'end_year':end.year(),
            'end_month':end.month(),
            'end_day':end.day(),
            'first_year': site_properties.calendar_starting_year,
            'year_range': now.year()-first_year + future_years,
            'filter_on': filter_on,
        }
        return drd

    security.declareProtected(View, 'getProjects')
    def getProjects(self, state=None, start=None, end=None):
        """
        Returns all projects in one of the states.
        state: sequence of states, if state is None, all projects are returned
        """
        catalog = self.getCatalog(return_objects=1)
        if self.getAllSite():
            path = '/'
        else:
            path = '/'.join(self.getPhysicalPath())
        if start and end:
            projects = catalog.getTypesInRange(start, end, portal_type='Project', path=path)
        else:
            projects = catalog.searchResults(portal_type='Project', path=path)
        return projects

    security.declareProtected(Permissions.delete_objects, 'deleteTracks')
    def deleteTracks(self, ids=None, REQUEST=None):
        "Delete a list of tracks. Notice ... ids is really paths"
        if ids is None:
            ids = []
        if ids:
            self.manage_delObjects(ids)
        if not REQUEST is None:
            REQUEST.RESPONSE.redirect(self.absolute_url())

    security.declareProtected(View, 'getTasks')
    def getTasks(self, status=None, start=None, end=None):
        """
        Returns all tasks/todos.
        """
        result = []
        for project in self.getProjects():
            result += project.getTasks(status, start, end)
        return result

    security.declareProtected(View, 'getMilestones')
    def getMilestones(self, start=None, end=None):
        """
        Returns all tasks/todos.
        """
        result = []
        for project in self.getProjects():
            result += project.getMilestones(start, end)
        return result


    # view methods

    security.declarePrivate('getTracksInRange')
    def getTracksInRange(self, start, end):
        """
        Returns tracks inside range.
        """
        return self.getProjects(start=start, end=end)


    security.declareProtected(View, 'view_mxmProjectManager_hours')
    def view_mxmProjectManager_hours(self):
        return HourAdapter(self)

    security.declareProtected(View, 'getHoursTable')
    def getHoursTable(self):
        "Returns a dict/StressAdapter"
        sa = StressAdapter(self)
        return sa.getHoursTable()


    def getStressAdapter(self):
        "Returns a stress adapter for viewing a stress table"
        return StressAdapter(self).getStressAdapter()

    def getMemberStressAdapter(self):
        "Returns a stress adapter for viewing a stress table"
        return StressAdapter(self).getMemberStressAdapter()

    security.declareProtected(View, 'getLanguageId')
    def getLanguageId(self):
        "Returns the id of the language from the PlacelessTranslationService"
        ts = getTranslationService()
        try: # this is probably not necessary, but I am not familliar with PTS, so it's a safe fallback.
            return ts.negotiate_language(self.REQUEST, self.portal_type.lower())
        except:
            return 'en'




registerType(mxmProjectManager,PROJECTNAME)
